VERSION 5.00
Begin VB.Form frmEcts 
   BackColor       =   &H00C0FFFF&
   Caption         =   "Econometrics Toolbox"
   ClientHeight    =   4635
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7455
   LinkTopic       =   "Form1"
   ScaleHeight     =   4635
   ScaleWidth      =   7455
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuLoadData 
         Caption         =   "&Load Data"
      End
      Begin VB.Menu mnuViewData 
         Caption         =   "&View Data"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuDataTransformation 
      Caption         =   "&Data Transformation"
      Begin VB.Menu mnuLog 
         Caption         =   "&Log"
      End
   End
   Begin VB.Menu mnuStatistics 
      Caption         =   "&Statistics"
      Begin VB.Menu mnuDescriptiveStatistics 
         Caption         =   "&Descriptive Statistics"
      End
      Begin VB.Menu mnuAdvancedStatistics 
         Caption         =   "&Advanced Statistics"
      End
   End
   Begin VB.Menu mnuEconometrics 
      Caption         =   "&Econometrics Modelling"
   End
   Begin VB.Menu mnuTSA 
      Caption         =   "&Time Series Analysis"
      Begin VB.Menu mnuArimaModels 
         Caption         =   "&Arima models"
      End
      Begin VB.Menu mnuStructuralModels 
         Caption         =   "&Structural models"
         Begin VB.Menu mnuLL 
            Caption         =   "&Local Level model"
         End
         Begin VB.Menu mnuLLT 
            Caption         =   "Local Linear &Trend model"
         End
         Begin VB.Menu mnuBSM 
            Caption         =   "&Basic Structural model"
         End
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "frmEcts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Form_Load()
    mnuViewData.Enabled = False
    mnuDataTransformation.Enabled = False
    mnuStatistics.Enabled = False
    mnuEconometrics.Enabled = False
    mnuTSA.Enabled = False
End Sub

Private Sub mnuCreate_Click()
    Dim DataFile As String
    Dim Nvar As Integer
    Dim Nobs As Integer
    Dim Names() As String
    Dim Data() As Double
    Dim fh As Byte
    
    DataFile = "c:\tmp\file1.asc"
    
    Nvar = 2
    Nobs = 50
    
    fh = FreeFile
    Open DataFile For Output As #fh
    
    Write #fh, Nvar
    Write #fh, Nobs
    Write #fh, "ser1", "ser2"
    
    Close #fh
    
End Sub

Private Sub mnuAdvancedStatistics_Click()
    frmEcts.Hide
    frmAS.Show
End Sub

Private Sub mnuDescriptiveStatistics_Click()
    frmEcts.Hide
    frmDS.Show
End Sub

Private Sub mnuExit_Click()
    End
End Sub

Private Sub mnuLL_Click()
    Dim Data() As Double
    Dim Nobs As Integer
    Dim I As Integer
    Dim GaussProgram As String
    
    Nobs = frmData.grdData.rows - 1
    
    ReDim Data(1 To Nobs, 1 To 1)
    
    frmData.grdData.Col = 0
    
    For I = 1 To Nobs
        frmData.grdData.Row = I
        Data(I, 1) = Val(frmData.grdData.Text)
    Next I
        
    gematput "data", Data()
    gestrput "model", "LL"
    
    geoutput "reset"
    GaussProgram = "library tsm,optmum; " + _
                   "{beta,stderr,Mcov,Logl} =  sm_LL(data,1|1);"
    geexec GaussProgram
    
    geoutput "show"
End Sub

Private Sub mnuLoadData_Click()
    Dim DataFile As String
    Dim Nobs As Integer
    Dim DataName As String
    Dim Data As Double
    Dim fh As Byte
    
    DataFile = InputBox("Enter the file name of the ASCII data:", _
                        "Load Data")
                        
                        
    On Error GoTo LoadData_error
    
    fh = FreeFile
    Open DataFile For Input As #fh
    
    Input #fh, Nobs
    Input #fh, DataName
    
    frmData.grdData.ColWidth(0) = 3510
    frmData.grdData.rows = Nobs + 1
    frmData.grdData.Col = 0
    frmData.grdData.Row = 0
    frmData.grdData.Text = DataName
    
    For I = 1 To Nobs
        Input #fh, Data
        frmData.grdData.Row = I
        frmData.grdData.Text = str(Data)
    Next I
    
    Close #fh
    
    mnuViewData.Enabled = True
    mnuDataTransformation.Enabled = True
    mnuStatistics.Enabled = True
    mnuEconometrics.Enabled = True
    mnuTSA.Enabled = True
    
    Exit Sub
    
LoadData_error:
    MsgBox "File not found"
    Exit Sub
    
End Sub

Private Sub mnuLog_Click()
    Dim Nobs As Integer
    Dim Data As Double
    Dim I As Integer
    
    Nobs = frmData.grdData.rows - 1
    
    frmData.grdData.Col = 0
    frmData.grdData.Row = 0
    frmData.grdData.Text = "LOG(" + frmData.grdData.Text + ")"
    
    For I = 1 To Nobs
        frmData.grdData.Row = I
        Data = Val(frmData.grdData.Text)
        Data = Log(Data) / Log(10#)
        frmData.grdData.Text = str(Data)
    Next I
    
    
End Sub


Private Sub mnuViewData_Click()
    frmEcts.Hide
    frmData.Show
End Sub
