new;
library optmum,VBgauss;

rndseed 123;  /* stability problem */

GaussPath = sysstate(2,0);
cnd = ChangeDir(GaussPath $+"VBgauss");

#include d:\gauss\vbgauss\rnd.src;

data = VBread("rnd","data");

OptionType = data[.,1];
K = data[.,2];
Premium = data[.,3];
F0 = data[.,4];
r = data[.,5];

inf = VBread("rnd","inf");

d = inf[1];
dtm = 100*inf[2] + 15;
minF = inf[3];
maxF = inf[4];
nF = inf[5];
dF = (maxF - minF) / (nF - 1);

tau = etdays_(d,dtm) .* ones(rows(Premium),1);

sigma = 0.01;

sv = (ln(F0[1])-0.5*sigma^2*tau[1])|(sigma*sqrt(tau[1])) |
     (ln(F0[1])-0.5*sigma^2*tau[1])|(sigma*sqrt(tau[1])) |
     0.4                                                 ;

output file = rnd.out reset;

theta = estimateRND(Premium,K,tau,r,OptionType,F0,sv);

print theta;

output off;

F = seqa(minF,dF,nF);
PDF = pdf2LN(F,theta[1],theta[2],theta[3],theta[4],theta[5]);

VBput("rnd",F~PDF,"F + PDF");

system;