/*
**> Bates91.prg
**
*/

new;
library option;

output file = option3.out reset;

S0 = 250;
b = 0;
r = 0.10;
tau = 0.25;

K = seqa(220,15,5);
let sigma[1,5] =  0.1414   0.10   0.10  0.10  0.10;
let lambdaStar[1,5] = 0       10     10     0.25  0.25;
let gammaStar[1,5] = 0        0.01  -0.01  0.20  -0.20;
let deltaStar[1,5] =  0        0.03   0.03  0      0;

kbarStar = exp(gammaStar) - 1;

_Option_Type = "call";
C =  EuropeanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);
_Option_Type = "put";
P = EuropeanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);

print "European option prices :";
call printfm(C,1,"*.*lf" ~ 8 ~ 2);
print;
call printfm(P,1,"*.*lf" ~ 8 ~ 2);
print;

@<-- row and column vectorisation using Kronecker product -->@

e = ones(5,1);
sigma = sigma' .*. e;
kbarStar = kbarStar' .*. e;
deltaStar = deltaStar' .*. e;
lambdaStar = lambdaStar' .*. e;

K = e .*. K;

_Option_Type = "call";
C = EuropeanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);
_Option_Type = "put";
P = EuropeanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);

C = reshape(C,5,5)';
P = reshape(P,5,5)';

print "European option prices :";
call printfm(C,1,"*.*lf" ~ 8 ~ 2);
print;
call printfm(P,1,"*.*lf" ~ 8 ~ 2);
print;


_Option_Type = "call";
C = AmericanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);
_Option_Type = "put";
P = AmericanMerton(S0,K,sigma,tau,b,r,kbarStar,deltaStar,lambdaStar);

C = reshape(C,5,5)';
P = reshape(P,5,5)';

print "American option prices :";
call printfm(C,1,"*.*lf" ~ 8 ~ 2);
print;
call printfm(P,1,"*.*lf" ~ 8 ~ 2);
print;

output off;

