new;
library tsm,optmum;

output file = tsm1a.out reset;

rndseed 123456;

p = 1; q = 1; beta = 0.8|0.4|0.25; sigma = 2;          /* d = 0.25 */
Nobs = 500;
{y,retcode} = RND_arfima(beta,p,q,sigma,1000,Nobs,1);  /* ARFIMA process simulation */

sv = 0.8|0.4|0.25|2;

@<--- first estimation --->@

cnt = 0|0|0|0;                                         /* No fixed parameters */

_tsm_Mcov = 1;    /* Hessian Matrix Covariance */
_fourier = 0;     /* Fast fourier transform    */
_tsm_optmum = 0;  /* scoring algorithm         */
__output = 1;
_print = 1;

{beta1,stderr,Mcov,Logl1} = arfima(y,1,1,sv,cnt);

_tsm_optmum = 1;  /* BFGS algorithm         */
__output = 0;
_print = 0;

@<--- second estimation --->@

sv = 0.8|0.4|0.25|2;
cnt = 0|0|1|0;                                         /* d is fixed */

{beta2,stderr,Mcov,Logl2} = arfima(y,1,1,sv,cnt);

@<--- third estimation --->@

sv = 0.8|0.4|0.25|2;
cnt = 0|1|1|0;                                         /* d and MA parameters are fixed */

{beta3,stderr,Mcov,Logl3} = arfima(y,1,1,sv,cnt);

@<--- likelihood ratio tests --->@

LR = 2*(logl1-logl2);      /* Likelihood ratio                             */
pvalue = cdfchic(LR,1);    /* Approximating the noncentral chi-squared CDF */

print;
print "Testing d = 0.25"; print chrs(45*ones(40,1));
print ftos(LR,"Likelihood ratio statistic: %lf",10,5);
print ftos(pvalue,"p-value: %lf",10,5);
print; print;

LR = 2*(logl1-logl3);      /* Likelihood ratio                             */
pvalue = cdfchic(LR,2);    /* Approximating the noncentral chi-squared CDF */

print "Testing d = 0.25 and theta1 = 0.4"; print chrs(45*ones(40,1));
print ftos(LR,"Likelihood ratio statistic: %lf",10,5);
print ftos(pvalue,"p-value: %lf",10,5);

output off;





