new;
library tsm,optmum,pgraph;
TSMset;

#include 2LN.src;

output file = tsm2c.out reset;

load data[] = frfdem.asc;
s = packr(log(data));

_kernel[1:2] = 0.522|0.534;

/* Density estimation by Kernel */

{x,pdfKernel,cdfKernel,retcode} = Kernel(s);

/* Log-Normal */

proc H(theta);
  local mu,sigma,h1,h2;

  mu = theta[1];
  sigma = sqrt(theta[2]^2);

  /* first moment E[z] = exp(mu+0.5*sigma^2) */
  h1 = s - exp(mu+0.5*sigma^2);

  /* second moment var[z] = exp(2*mu+sigma^2)*(exp(sigma^2)-1) */
  h2 = h1.*h1 - exp(2*mu+sigma^2)*(exp(sigma^2)-1);

  retp(h1~h2);
endp;

_gmm_lags = 0;
_gmm_iter = 2;
__output = 1;
_print = 0;
_tsm_parnm = "mu"|"sigma";

sv = ln(meanc(s))|.1;
{theta,stderr,Mcov,Qmin} = gmm(&H,sv);
mu = theta[1];
sigma = sqrt(theta[2]^2);
pdfGMM1 = pdfLN(x,mu,sigma);

proc SimulatedMoments(theta);
  local mu,sigma;
  local N,u;
  local M1,uc,M2;
  local h1,h2;

  mu = theta[1];
  sigma = sqrt(theta[2]^2);

  N = 1000;  /* number of simulations */

  rndseed 123456; /* always use the same random numbers */

  u = rndLN(mu,sigma,N,1);

  M1 = meanc(u);
  uc = u - M1;
  M2 = meanc(uc^2);

  /* first moment */
  h1 = s - M1;

  /* second moment */
  h2 = h1.*h1 - M2;

  retp(h1~h2);
endp;

{theta,stderr,Mcov,Qmin} = gmm(&SimulatedMoments,sv);
mu = theta[1];
sigma = sqrt(theta[2]^2);
pdfGMM2 = pdfLN(x,mu,sigma);

graphset;
  _pdate = ""; _pnum = 2; _pltype = 6|1|3;
  _plegstr = "Gaussian Kernel\000log-normal density (GMM)\000log-normal density (SMM)";
  _plegctl = {2 5 1 3};
  xtics(0.522,0.534,0.002,0);
  graphprt("-c=1 -cf=tsm2c.eps");
  xy(x,pdfKernel~pdfGMM1~pdfGMM2);
