/* --- The following code comes from c:\lcc\lib\wizard\dll.tpl. */

#include <string.h>
#include <windows.h>
#include <stdio.h>

//
//  FUNCTION: DLLMain(HINSTANCE, DWORD, LPVOID)
//  PURPOSE:  Called when DLL is loaded by a process, and when new
//    threads are created by a process that has already loaded the
//    DLL.  Also called when threads of a process that has loaded the
//    DLL exit cleanly and when the process itself unloads the DLL.
//  PARAMETERS:
//    hDLLInst    - Instance handle of the DLL
//    fdwReason   - Process attach/detach or thread attach/detach
//    lpvReserved - Reserved and not used
//  RETURN VALUE:  (Used only when fdwReason == DLL_PROCESS_ATTACH)
//    TRUE  -  Used to signify that the DLL should remain loaded.
//    FALSE -  Used to signify that the DLL should be immediately unloaded.
//

BOOL WINAPI LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // The DLL is being loaded for the first time by a given process.
            // Perform per-process initialization here.  If the initialization
            // is successful, return TRUE; if unsuccessful, return FALSE.


            break;
        case DLL_PROCESS_DETACH:
            // The DLL is being unloaded by a given process.  Do any
            // per-process clean up here, such as undoing what was done in
            // DLL_PROCESS_ATTACH.  The return value is ignored.


            break;
        case DLL_THREAD_ATTACH:
            // A thread is being created in a process that has already loaded
            // this DLL.  Perform any per-thread initialization here.  The
            // return value is ignored.

            break;
        case DLL_THREAD_DETACH:
            // A thread is exiting cleanly in a process that has already
            // loaded this DLL.  Perform any per-thread clean up here.  The
            // return value is ignored.

            break;
    }
    return TRUE;
}


__declspec(dllexport) int dllDestroyWindow(char *lpWindowName)
{
	char _lpWindowName[256];
	long *hwnd;
	strcpy(_lpWindowName,lpWindowName);
	hwnd = FindWindow(0,_lpWindowName);
	DestroyWindow(hwnd);
	return 0;
}

__declspec(dllexport) int dllFlashWindow(char *lpWindowName,double *bInvert)
{
	char _lpWindowName[256];
	long *hwnd;
	long _bInvert;
	strcpy(_lpWindowName,lpWindowName);
	hwnd = FindWindow(0,_lpWindowName);
	_bInvert = (long) *bInvert;
	FlashWindow(hwnd,_bInvert);
	return 0;
}

__declspec(dllexport) int dllMessageBox(double *ret,char *lpText,char *lpCaption,double *wType)
{
	char _lpText[255];
	char _lpCaption[255];
	strcpy(_lpText,lpText);
	strcpy(_lpCaption,lpCaption);
	*ret = MessageBox(NULL,_lpText,_lpCaption,*wType);
	return 0;
}

__declspec(dllexport) int dllMoveWindow(char *lpWindowName,double *x,double *y,double *nWidth,
                                        double *nHeight,double *bRepaint)
{
	char _lpWindowName[256];
	long *hwnd;
	int _x;
	int _y;
	int _nWidth;
	int _nHeight;
	int _bRepaint;	
	strcpy(_lpWindowName,lpWindowName);
	hwnd = FindWindow(0,_lpWindowName);
	_x = (int) *x;
	_y = (int) *y;
	_nWidth = (int) *nWidth;
	_nHeight = (int) *nHeight;
	_bRepaint = (int) *bRepaint;	
	MoveWindow(hwnd,_x,_y,_nWidth,_nHeight,_bRepaint);
	return 0;
}


__declspec(dllexport) int dllShowWindow(char *lpWindowName,double *nCmdShow)
{
	char _lpWindowName[256];
	long *hwnd;
	long _nCmdShow;
	strcpy(_lpWindowName,lpWindowName);
	hwnd = FindWindow(0,_lpWindowName);
	_nCmdShow = (long) *nCmdShow;
	ShowWindow(hwnd,_nCmdShow);
	return 0;
}


